# -*- coding: utf-8 -*-

from xml.sax import saxutils
from xml.sax import make_parser
from xml.sax.handler import feature_namespaces
import sys
import string

def print_info(text):
    print "[INFO ] " + text
def print_error(text):
    print "[ERROR] " + text
def print_warning(text):
    print "[WARN ] " + text

def main(args):

    # Create a parser
    parser = make_parser()
    # Tell the parser we are not interested in XML namespaces
    parser.setFeature(feature_namespaces, 0)

    # Create the handler
    dh = FindIssue("module")

    # Tell the parser to use our handler
    parser.setContentHandler(dh)

    # Parse the input
    parser.parse("modules/rly1-module.xml")


class FindIssue(saxutils.DefaultHandler):
    def __init__(self, title):
        self.search_title = title

        print_info("Element: " + self.search_title)

    def normalize_whitespace(text):
        #Remove redundant whitespace from a string
        return ' '.join(text.split())

    def error(self, exception):
        print_error("An error occured while parsing the XML file: " + exception)

    def startElement(self, name, attrs):
        # If it's not a comic element, ignore it
        if name != 'module': return

        # Look for the title and number attributes (see text)
        attrib = "name"
        value = attrs.get(attrib, None)

        print_info("Attribute: Name = " + attrib + " , Value = " + value)


    def endElement(self, name):
        if name == 'writer':
            self.inWriterContent = 0
            self.writerName = normalize_whitespace(self.writerName)
            if self.search_name == self.writerName:
                print 'Found:', self.this_title, self.this_number


if __name__ == '__main__':
    # Get any command-line arguments passed from the terminal
    arguments = []
    for arg in sys.argv:
        arguments.append(arg)

    main(arguments)